﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

#region Credits
    /*Copyright © iMCSProduction 2013.
    Thanks to BuC-ShoTz for have contributed to this.
    Thanks to CraigChrist for his extension base for xbox.
    Visit www.NextGenUpdate.com if you're English.
    Visit www.FrenchModdingTeam.com if you're French.
    Follow me www.Twitter.com/iMCSx - www.Youtube.com/iMCSx*/
#endregion

namespace PS3Lib
{
    public static class GetPs3Api
    {
        #region
        /// <summary>Load the PS3 API for use with your Application .NET.
        /// <para>Here's how you could make a second paragraph in a description. <see cref="System.Console.WriteLine(System.String)"/> for information about output statements.</para>
        /// <seealso cref="TestClass.Main"/>
        /// </summary>
        #endregion

        internal static Assembly LoadApi;
        ///<summary>Load the PS3 API for use with your Application .NET.</summary>
        public static Assembly PS3TMAPI_NET()
        {
            AppDomain.CurrentDomain.AssemblyResolve += (s, e) =>
            {
                var filename = new AssemblyName(e.Name).Name;
                var x = string.Format(@"C:\Program Files\SN Systems\PS3\bin\ps3tmapi_net.dll", filename);
                var x64 = string.Format(@"C:\Program Files (x64)\SN Systems\PS3\bin\ps3tmapi_net.dll", filename);
                var x86 = string.Format(@"C:\Program Files (x86)\SN Systems\PS3\bin\ps3tmapi_net.dll", filename);
                if (System.IO.File.Exists(x))
                    LoadApi = Assembly.LoadFile(x);
                else
                {
                    if (System.IO.File.Exists(x64))
                        LoadApi = Assembly.LoadFile(x64);

                    else
                    {
                        if (System.IO.File.Exists(x86))
                            LoadApi = Assembly.LoadFile(x86);
                        else
                        {
                            MessageBox.Show("Target Manager API cannot be founded to:\r\n\r\n" + x86, "Error with PS3 API!", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        }
                    }
                }
                return LoadApi;
            };
            return LoadApi;
        }
    }
}
